import random

data = [[4.1, 3.85, 2.2, 1], [3.7, 3.4, 2.2, 1], [4.7, 2.8, 1.7, 1], [4.5, 3.25, 2.4, 1], [4.4, 3.25, 2.5, 1], [4.8, 2.75, 1.4, 1], [4.0, 3.7, 2.3, 1], [5.0, 2.2, 2.0, 1], [4.5, 3.65, 2.3, 1], [5.1, 3.25, 2.4, 1], [4.3, 3.65, 2.7, 1], [5.1, 3.35, 2.3, 1], [5.3, 3.4, 2.2, 1], [4.9, 3.5, 2.8, 1], [4.3, 2.75, 2.6, 1], [4.1, 2.5, 1.3, 1], [4.5, 3.65, 1.8, 1], [4.8, 3.3, 2.0, 1], [4.5, 3.6, 2.0, 1], [5.1, 2.05, 1.4, 1], [3.6, 2.3, 1.1, 0], [3.5, 2.1, 2.8, 0], [3.9, 2.8, 1.3, 0], [3.4, 2.8, 1.1, 0], [3.9, 2.5, 2.7, 0], [3.9, 2.9, 2.3, 0], [3.5, 2.2, 2.2, 0], [3.5, 2.7, 2.8, 0], [3.1, 2.3, 1.2, 0], [3.2, 2.2, 2.8, 0], [3.1, 2.9, 2.0, 0], [3.2, 2.3, 2.4, 0], [3.5, 2.7, 2.0, 0], [3.5, 2.1, 2.1, 0], [3.1, 2.5, 2.3, 0], [3.3, 2.5, 2.7, 0], [3.7, 2.5, 2.4, 0], [3.7, 2.7, 2.0, 0], [3.5, 2.9, 1.4, 0], [3.1, 2.5, 1.4, 0]]

#Le point dont on cherche la couleur
question = [3.5, 3.2, 2.2]

def prediction(carte, W):
    o = W[0]*carte[0] + W[1]*carte[1] + W[2]*carte[2] + W[3]
    if o > 0:
        predict = 1
    else:
        predict = 0
    return predict

def ajust(pas, carte, W, E):
    W[0] = W[0] + pas*carte[0]*E
    W[1] = W[1] + pas*carte[1]*E
    W[2] = W[2] + pas*carte[2]*E
    W[3] = W[3] + pas*E
    return W

def taux(data, W):#Calcul du taux d'échecs
    echecs = 0
    for carte in data:
        if prediction(carte, W) != carte[3]:
            echecs += 1
    return echecs/len(data)


#====Initialisation:====
pas = 0.1
poids = [5, 3, 1, -15]
#====Entrainement:====

#Sélection de 20 cartes au hasard:
select = random.sample(data, 20)

for carte in select:
    predict = prediction(carte, poids)
    #Calcul de l'erreur:
    E = carte[3]-predict
    poids = ajust(pas, carte, poids, E)
    print(taux(data, poids))

print(poids)

#======================Plot 3D=============================
import matplotlib.pyplot as plt
from matplotlib import cm
import mpl_toolkits.mplot3d
import numpy as np

#Possibilité de tester certains poids trouvés
#poids = [2.9, 1.5, -0.1, -15.6]

fig = plt.figure()
ax = fig.add_subplot(projection='3d')

#Les données :
for carte in data:
    if carte[3] == 1:
        ax.scatter(carte[0], carte[1], carte[2], marker='o', color=(1, 0, 0))
    else:
        ax.scatter(carte[0], carte[1], carte[2], marker='o', color=(0, 0, 1))

#ax.scatter(question[0], question[1], question[2], marker='*', color=(0, 1, 0))

#Le plan de séparation :
X = np.arange(2, 5, 0.5)
Y = np.arange(2, 5, 0.5)
X, Y = np.meshgrid(X, Y)
Z = (poids[0]*X + poids[1]*Y + poids[3])/(-poids[2])
ax.plot_surface(X, Y, Z, cmap=cm.coolwarm, linewidth=0, antialiased=False)

ax.set_xlabel('X Label')
ax.set_ylabel('Y Label')
ax.set_zlabel('Z Label')

plt.show()